java.util

## Class Locale

- java.lang.Object
- - java.util.Locale

- All Implemented Interfaces:
    Serializable, Cloneable

      public final class Locale
      extends Object
      implements Cloneable, Serializable

  A `Locale` object represents a specific geographical, political, or cultural region. An operation that requires a `Locale` to perform its task is called locale-sensitive and uses the `Locale` to tailor information for the user. For example, displaying a number is a locale-sensitive operation— the number should be formatted according to the customs and conventions of the user's native country, region, or culture.

  The `Locale` class implements identifiers interchangeable with BCP 47 (IETF BCP 47, "Tags for Identifying Languages"), with support for the LDML (UTS#35, "Unicode Locale Data Markup Language") BCP 47-compatible extensions for locale data exchange.

  A `Locale` object logically consists of the fields described below.

  language
    ISO 639 alpha-2 or alpha-3 language code, or registered language subtags up to 8 alpha letters (for future enhancements). When a language has both an alpha-2 code and an alpha-3 code, the alpha-2 code must be used. You can find a full list of valid language codes in the IANA Language Subtag Registry (search for "Type: language"). The language field is case insensitive, but `Locale` always canonicalizes to lower case.
    Well-formed language values have the form `[a-zA-Z]{2,8}`. Note that this is not the the full BCP47 language production, since it excludes extlang. They are not needed since modern three-letter language codes replace them.
    Example: "en" (English), "ja" (Japanese), "kok" (Konkani)
  script
    ISO 15924 alpha-4 script code. You can find a full list of valid script codes in the IANA Language Subtag Registry (search for "Type: script"). The script field is case insensitive, but `Locale` always canonicalizes to title case (the first letter is upper case and the rest of the letters are lower case).
    Well-formed script values have the form `[a-zA-Z]{4}`
    Example: "Latn" (Latin), "Cyrl" (Cyrillic)
  country (region)
    ISO 3166 alpha-2 country code or UN M.49 numeric-3 area code. You can find a full list of valid country and region codes in the IANA Language Subtag Registry (search for "Type: region"). The country (region) field is case insensitive, but `Locale` always canonicalizes to upper case.
    Well-formed country/region values have the form `[a-zA-Z]{2} | [0-9]{3}`
    Example: "US" (United States), "FR" (France), "029" (Caribbean)
  variant
    Any arbitrary value used to indicate a variation of a `Locale`. Where there are two or more variant values each indicating its own semantics, these values should be ordered by importance, with most important first, separated by underscore('_'). The variant field is case sensitive.
    Note: IETF BCP 47 places syntactic restrictions on variant subtags. Also BCP 47 subtags are strictly used to indicate additional variations that define a language or its dialects that are not covered by any combinations of language, script and region subtags. You can find a full list of valid variant codes in the IANA Language Subtag Registry (search for "Type: variant").

    However, the variant field in `Locale` has historically been used for any kind of variation, not just language variations. For example, some supported variants available in Java SE Runtime Environments indicate alternative cultural behaviors such as calendar type or number script. In BCP 47 this kind of information, which does not identify the language, is supported by extension subtags or private use subtags.

    Well-formed variant values have the form `SUBTAG (('_'|'-') SUBTAG)*` where `SUBTAG = [0-9][0-9a-zA-Z]{3} | [0-9a-zA-Z]{5,8}`. (Note: BCP 47 only uses hyphen ('-') as a delimiter, this is more lenient).
    Example: "polyton" (Polytonic Greek), "POSIX"
  extensions
    A map from single character keys to string values, indicating extensions apart from language identification. The extensions in `Locale` implement the semantics and syntax of BCP 47 extension subtags and private use subtags. The extensions are case insensitive, but `Locale` canonicalizes all extension keys and values to lower case. Note that extensions cannot have empty values.
    Well-formed keys are single characters from the set `[0-9a-zA-Z]`. Well-formed values have the form `SUBTAG ('-' SUBTAG)*` where for the key 'x' `SUBTAG = [0-9a-zA-Z]{1,8}` and for other keys `SUBTAG = [0-9a-zA-Z]{2,8}` (that is, 'x' allows single-character subtags).
    Example: key="u"/value="ca-japanese" (Japanese Calendar), key="x"/value="java-1-7"
  Note: Although BCP 47 requires field values to be registered in the IANA Language Subtag Registry, the `Locale` class does not provide any validation features. The `Builder` only checks if an individual field satisfies the syntactic requirement (is well-formed), but does not validate the value itself. See `Builder` for details.

  #### Unicode locale/language extension

  UTS#35, "Unicode Locale Data Markup Language" defines optional attributes and keywords to override or refine the default behavior associated with a locale. A keyword is represented by a pair of key and type. For example, "nu-thai" indicates that Thai local digits (value:"thai") should be used for formatting numbers (key:"nu").

  The keywords are mapped to a BCP 47 extension value using the extension key 'u' (`UNICODE_LOCALE_EXTENSION`). The above example, "nu-thai", becomes the extension "u-nu-thai".code

  Thus, when a `Locale` object contains Unicode locale attributes and keywords, `getExtension(UNICODE_LOCALE_EXTENSION)` will return a String representing this information, for example, "nu-thai". The `Locale` class also provides `getUnicodeLocaleAttributes()`, `getUnicodeLocaleKeys()`, and `getUnicodeLocaleType(java.lang.String)` which allow you to access Unicode locale attributes and key/type pairs directly. When represented as a string, the Unicode Locale Extension lists attributes alphabetically, followed by key/type sequences with keys listed alphabetically (the order of subtags comprising a key's type is fixed when the type is defined)

  A well-formed locale key has the form `[0-9a-zA-Z]{2}`. A well-formed locale type has the form `"" | [0-9a-zA-Z]{3,8} ('-' [0-9a-zA-Z]{3,8})*` (it can be empty, or a series of subtags 3-8 alphanums in length). A well-formed locale attribute has the form `[0-9a-zA-Z]{3,8}` (it is a single subtag with the same form as a locale type subtag).

  The Unicode locale extension specifies optional behavior in locale-sensitive services. Although the LDML specification defines various keys and values, actual locale-sensitive service implementations in a Java Runtime Environment might not support any particular Unicode locale attributes or key/type pairs.

  #### Creating a Locale

  There are several different ways to create a `Locale` object.

  ##### Builder

  Using `Builder` you can construct a `Locale` object that conforms to BCP 47 syntax.

  ##### Constructors

  The `Locale` class provides three constructors:

  >          Locale(String language)
  >          Locale(String language, String country)
  >          Locale(String language, String country, String variant)

  These constructors allow you to create a `Locale` object with language, country and variant, but you cannot specify script or extensions.

  ##### Factory Methods

  The method `#forLanguageTag` creates a `Locale` object for a well-formed BCP 47 language tag.

  ##### Locale Constants

  The `Locale` class provides a number of convenient constants that you can use to create `Locale` objects for commonly used locales. For example, the following creates a `Locale` object for the United States:

  >          Locale.US

  #### Use of Locale

  Once you've created a `Locale` you can query it for information about itself. Use `getCountry` to get the country (or region) code and `getLanguage` to get the language code. You can use `getDisplayCountry` to get the name of the country suitable for displaying to the user. Similarly, you can use `getDisplayLanguage` to get the name of the language suitable for displaying to the user. Interestingly, the `getDisplayXXX` methods are themselves locale-sensitive and have two versions: one that uses the default locale and one that uses the locale specified as an argument.

  The Java Platform provides a number of classes that perform locale-sensitive operations. For example, the `NumberFormat` class formats numbers, currency, and percentages in a locale-sensitive manner. Classes such as `NumberFormat` have several convenience methods for creating a default object of that type. For example, the `NumberFormat` class provides these three convenience methods for creating a default `NumberFormat` object:

  >          NumberFormat.getInstance()
  >          NumberFormat.getCurrencyInstance()
  >          NumberFormat.getPercentInstance()

  Each of these methods has two variants; one with an explicit locale and one without; the latter uses the default locale:

  >          NumberFormat.getInstance(myLocale)
  >          NumberFormat.getCurrencyInstance(myLocale)
  >          NumberFormat.getPercentInstance(myLocale)

  A `Locale` is the mechanism for identifying the kind of object (`NumberFormat`) that you would like to get. The locale is just a mechanism for identifying objects, not a container for the objects themselves.

  #### Compatibility

  In order to maintain compatibility with existing usage, Locale's constructors retain their behavior prior to the Java Runtime Environment version 1.7. The same is largely true for the `toString` method. Thus Locale objects can continue to be used as they were. In particular, clients who parse the output of toString into language, country, and variant fields can continue to do so (although this is strongly discouraged), although the variant field will have additional information in it if script or extensions are present.

  In addition, BCP 47 imposes syntax restrictions that are not imposed by Locale's constructors. This means that conversions between some Locales and BCP 47 language tags cannot be made without losing information. Thus `toLanguageTag` cannot represent the state of locales whose language, country, or variant do not conform to BCP 47.

  Because of these issues, it is recommended that clients migrate away from constructing non-conforming locales and use the `forLanguageTag` and `Locale.Builder` APIs instead. Clients desiring a string representation of the complete locale can then always rely on `toLanguageTag` for this purpose.

  ##### Special cases

  For compatibility reasons, two non-conforming locales are treated as special cases. These are `ja_JP_JP` and `th_TH_TH`. These are ill-formed in BCP 47 since the variants are too short. To ease migration to BCP 47, these are treated specially during construction. These two cases (and only these) cause a constructor to generate an extension, all other values behave exactly as they did prior to Java 7.

  Java has used `ja_JP_JP` to represent Japanese as used in Japan together with the Japanese Imperial calendar. This is now representable using a Unicode locale extension, by specifying the Unicode locale key `ca` (for "calendar") and type `japanese`. When the Locale constructor is called with the arguments "ja", "JP", "JP", the extension "u-ca-japanese" is automatically added.

  Java has used `th_TH_TH` to represent Thai as used in Thailand together with Thai digits. This is also now representable using a Unicode locale extension, by specifying the Unicode locale key `nu` (for "number") and value `thai`. When the Locale constructor is called with the arguments "th", "TH", "TH", the extension "u-nu-thai" is automatically added.

  ##### Serialization

  During serialization, writeObject writes all fields to the output stream, including extensions.

  During deserialization, readResolve adds extensions as described in Special Cases, only for the two cases th_TH_TH and ja_JP_JP.

  ##### Legacy language codes

  Locale's constructor has always converted three language codes to their earlier, obsoleted forms: `he` maps to `iw`, `yi` maps to `ji`, and `id` maps to `in`. This continues to be the case, in order to not break backwards compatibility.

  The APIs added in 1.7 map between the old and new language codes, maintaining the old codes internal to Locale (so that `getLanguage` and `toString` reflect the old code), but using the new codes in the BCP 47 language tag APIs (so that `toLanguageTag` reflects the new one). This preserves the equivalence between Locales no matter which code or API is used to construct them. Java's default resource bundle lookup mechanism also implements this mapping, so that resources can be named using either convention, see `ResourceBundle.Control`.

  ##### Three-letter language/country(region) codes

  The Locale constructors have always specified that the language and the country param be two characters in length, although in practice they have accepted any length. The specification has now been relaxed to allow language codes of two to eight characters and country (region) codes of two to three characters, and in particular, three-letter language codes and three-digit region codes as specified in the IANA Language Subtag Registry. For compatibility, the implementation still does not impose a length constraint.

  Since:
    1.1
  Author:
    Mark Davis
  See Also:
    `Builder`, `ResourceBundle`, `Format`, `NumberFormat`, `Collator`, Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Locale.Category` Enum for locale categories.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Locale` | `CANADA` Useful constant for country.
    `static Locale` | `CANADA_FRENCH` Useful constant for country.
    `static Locale` | `CHINA` Useful constant for country.
    `static Locale` | `CHINESE` Useful constant for language.
    `static Locale` | `ENGLISH` Useful constant for language.
    `static Locale` | `FRANCE` Useful constant for country.
    `static Locale` | `FRENCH` Useful constant for language.
    `static Locale` | `GERMAN` Useful constant for language.
    `static Locale` | `GERMANY` Useful constant for country.
    `static Locale` | `ITALIAN` Useful constant for language.
    `static Locale` | `ITALY` Useful constant for country.
    `static Locale` | `JAPAN` Useful constant for country.
    `static Locale` | `JAPANESE` Useful constant for language.
    `static Locale` | `KOREA` Useful constant for country.
    `static Locale` | `KOREAN` Useful constant for language.
    `static Locale` | `PRC` Useful constant for country.
    `static char` | `PRIVATE_USE_EXTENSION` The key for the private use extension ('x').
    `static Locale` | `ROOT` Useful constant for the root locale.
    `static Locale` | `SIMPLIFIED_CHINESE` Useful constant for language.
    `static Locale` | `TAIWAN` Useful constant for country.
    `static Locale` | `TRADITIONAL_CHINESE` Useful constant for language.
    `static Locale` | `UK` Useful constant for country.
    `static char` | `UNICODE_LOCALE_EXTENSION` The key for Unicode locale extension ('u').
    `static Locale` | `US` Useful constant for country.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Locale(String language)` Construct a locale from a language code.
    `Locale(String language, String country)` Construct a locale from language and country.
    `Locale(String language, String country, String variant)` Construct a locale from language, country and variant.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object` | `clone()` Overrides Cloneable.
    `boolean` | `equals(Object obj)` Indicates whether some other object is "equal to" this one.
    `static Locale[]` | `getAvailableLocales()` Returns an array of all installed locales.
    `String` | `getCountry()` Returns the country/region code for this locale, which should either be the empty string, an uppercase ISO 3166 2-letter code, or a UN M.49 3-digit code.
    `static Locale` | `getDefault()` Gets the current value of the default locale for this instance of the Java Virtual Machine.
    `static Locale` | `getDefault(Locale.Category category)` Gets the current value of the default locale for the specified Category for this instance of the Java Virtual Machine.
    `String` | `getExtension(char key)` Returns the extension (or private use) value associated with the specified key, or null if there is no extension associated with the key.
    `Set<Character>` | `getExtensionKeys()` Returns the set of extension keys associated with this locale, or the empty set if it has no extensions.
    `String` | `getLanguage()` Returns the language code of this Locale.
    `String` | `getScript()` Returns the script for this locale, which should either be the empty string or an ISO 15924 4-letter script code.
    `Set<String>` | `getUnicodeLocaleAttributes()` Returns the set of unicode locale attributes associated with this locale, or the empty set if it has no attributes.
    `Set<String>` | `getUnicodeLocaleKeys()` Returns the set of Unicode locale keys defined by this locale, or the empty set if this locale has none.
    `String` | `getUnicodeLocaleType(String key)` Returns the Unicode locale type associated with the specified Unicode locale key for this locale.
    `String` | `getVariant()` Returns the variant code for this locale.
    `int` | `hashCode()` Override hashCode.
    `static void` | `setDefault(Locale newLocale)` Sets the default locale for this instance of the Java Virtual Machine.
    `String` | `toString()` Returns a string representation of this `Locale` object, consisting of language, country, variant, script, and extensions as below:

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ENGLISH

          public static final Locale ENGLISH

      Useful constant for language.

    - #### FRENCH

          public static final Locale FRENCH

      Useful constant for language.

    - #### GERMAN

          public static final Locale GERMAN

      Useful constant for language.

    - #### ITALIAN

          public static final Locale ITALIAN

      Useful constant for language.

    - #### JAPANESE

          public static final Locale JAPANESE

      Useful constant for language.

    - #### KOREAN

          public static final Locale KOREAN

      Useful constant for language.

    - #### CHINESE

          public static final Locale CHINESE

      Useful constant for language.

    - #### SIMPLIFIED_CHINESE

          public static final Locale SIMPLIFIED_CHINESE

      Useful constant for language.

    - #### TRADITIONAL_CHINESE

          public static final Locale TRADITIONAL_CHINESE

      Useful constant for language.

    - #### FRANCE

          public static final Locale FRANCE

      Useful constant for country.

    - #### GERMANY

          public static final Locale GERMANY

      Useful constant for country.

    - #### ITALY

          public static final Locale ITALY

      Useful constant for country.

    - #### JAPAN

          public static final Locale JAPAN

      Useful constant for country.

    - #### KOREA

          public static final Locale KOREA

      Useful constant for country.

    - #### CHINA

          public static final Locale CHINA

      Useful constant for country.

    - #### PRC

          public static final Locale PRC

      Useful constant for country.

    - #### TAIWAN

          public static final Locale TAIWAN

      Useful constant for country.

    - #### UK

          public static final Locale UK

      Useful constant for country.

    - #### US

          public static final Locale US

      Useful constant for country.

    - #### CANADA

          public static final Locale CANADA

      Useful constant for country.

    - #### CANADA_FRENCH

          public static final Locale CANADA_FRENCH

      Useful constant for country.

    - #### ROOT

          public static final Locale ROOT

      Useful constant for the root locale. The root locale is the locale whose language, country, and variant are empty ("") strings. This is regarded as the base locale of all locales, and is used as the language/country neutral locale for the locale sensitive operations.
      Since:
        1.6

    - #### PRIVATE_USE_EXTENSION

          public static final char PRIVATE_USE_EXTENSION

      The key for the private use extension ('x').
      Since:
        1.7
      See Also:
        `getExtension(char)`, `Builder#setExtension(char, String)`, Constant Field Values

    - #### UNICODE_LOCALE_EXTENSION

          public static final char UNICODE_LOCALE_EXTENSION

      The key for Unicode locale extension ('u').
      Since:
        1.7
      See Also:
        `getExtension(char)`, `Builder#setExtension(char, String)`, Constant Field Values

  - ### Constructor Detail

    - #### Locale

          public Locale(String language,
                        String country,
                        String variant)

      Construct a locale from language, country and variant. This constructor normalizes the language value to lowercase and the country value to uppercase.

      Note:

      - ISO 639 is not a stable standard; some of the language codes it defines (specifically "iw", "ji", and "in") have changed. This constructor accepts both the old codes ("iw", "ji", and "in") and the new codes ("he", "yi", and "id"), but all other API on Locale will return only the OLD codes.
      - For backward compatibility reasons, this constructor does not make any syntactic checks on the input.
      - The two cases ("ja", "JP", "JP") and ("th", "TH", "TH") are handled specially, see Special Cases for more information.
      Parameters:
        `language` - An ISO 639 alpha-2 or alpha-3 language code, or a language subtag up to 8 characters in length. See the `Locale` class description about valid language values.
        `country` - An ISO 3166 alpha-2 country code or a UN M.49 numeric-3 area code. See the `Locale` class description about valid country values.
        `variant` - Any arbitrary value used to indicate a variation of a `Locale`. See the `Locale` class description for the details.
      Throws:
        `NullPointerException` - thrown if any argument is null.

    - #### Locale

          public Locale(String language,
                        String country)

      Construct a locale from language and country. This constructor normalizes the language value to lowercase and the country value to uppercase.

      Note:

      - ISO 639 is not a stable standard; some of the language codes it defines (specifically "iw", "ji", and "in") have changed. This constructor accepts both the old codes ("iw", "ji", and "in") and the new codes ("he", "yi", and "id"), but all other API on Locale will return only the OLD codes.
      - For backward compatibility reasons, this constructor does not make any syntactic checks on the input.
      Parameters:
        `language` - An ISO 639 alpha-2 or alpha-3 language code, or a language subtag up to 8 characters in length. See the `Locale` class description about valid language values.
        `country` - An ISO 3166 alpha-2 country code or a UN M.49 numeric-3 area code. See the `Locale` class description about valid country values.
      Throws:
        `NullPointerException` - thrown if either argument is null.

    - #### Locale

          public Locale(String language)

      Construct a locale from a language code. This constructor normalizes the language value to lowercase.

      Note:

      - ISO 639 is not a stable standard; some of the language codes it defines (specifically "iw", "ji", and "in") have changed. This constructor accepts both the old codes ("iw", "ji", and "in") and the new codes ("he", "yi", and "id"), but all other API on Locale will return only the OLD codes.
      - For backward compatibility reasons, this constructor does not make any syntactic checks on the input.
      Parameters:
        `language` - An ISO 639 alpha-2 or alpha-3 language code, or a language subtag up to 8 characters in length. See the `Locale` class description about valid language values.
      Throws:
        `NullPointerException` - thrown if argument is null.
      Since:
        1.4

  - ### Method Detail

    - #### getDefault

          public static Locale getDefault()

      Gets the current value of the default locale for this instance of the Java Virtual Machine.

      The Java Virtual Machine sets the default locale during startup based on the host environment. It is used by many locale-sensitive methods if no locale is explicitly specified. It can be changed using the `setDefault` method.

      Returns:
        the default locale for this instance of the Java Virtual Machine

    - #### getDefault

          public static Locale getDefault(Locale.Category category)

      Gets the current value of the default locale for the specified Category for this instance of the Java Virtual Machine.

      The Java Virtual Machine sets the default locale during startup based on the host environment. It is used by many locale-sensitive methods if no locale is explicitly specified. It can be changed using the setDefault(Locale.Category, Locale) method.

      Parameters:
        `category` - - the specified category to get the default locale
      Returns:
        the default locale for the specified Category for this instance of the Java Virtual Machine
      Throws:
        `NullPointerException` - - if category is null
      Since:
        1.7
      See Also:
        `#setDefault(Locale.Category, Locale)`

    - #### setDefault

          public static void setDefault(Locale newLocale)

      Sets the default locale for this instance of the Java Virtual Machine. This does not affect the host locale.

      If there is a security manager, its `checkPermission` method is called with a `PropertyPermission("user.language", "write")` permission before the default locale is changed.

      The Java Virtual Machine sets the default locale during startup based on the host environment. It is used by many locale-sensitive methods if no locale is explicitly specified.

      Since changing the default locale may affect many different areas of functionality, this method should only be used if the caller is prepared to reinitialize locale-sensitive code running within the same Java Virtual Machine.

      By setting the default locale with this method, all of the default locales for each Category are also set to the specified default locale.

      Parameters:
        `newLocale` - the new default locale
      Throws:
        `SecurityException` - if a security manager exists and its `checkPermission` method doesn't allow the operation.
        `NullPointerException` - if `newLocale` is null
      See Also:
        `SecurityManager.checkPermission(java.security.Permission)`, `PropertyPermission`

    - #### getAvailableLocales

          public static Locale[] getAvailableLocales()

      Returns an array of all installed locales. The returned array represents the union of locales supported by the Java runtime environment and by installed `LocaleServiceProvider` implementations. It must contain at least a `Locale` instance equal to `Locale.US`.
      Returns:
        An array of installed locales.

    - #### getLanguage

          public String getLanguage()

      Returns the language code of this Locale.

      Note: ISO 639 is not a stable standard— some languages' codes have changed. Locale's constructor recognizes both the new and the old codes for the languages whose codes have changed, but this function always returns the old code. If you want to check for a specific language whose code has changed, don't do

           if (locale.getLanguage().equals("he")) // BAD!
              ...

      Instead, do

           if (locale.getLanguage().equals(new Locale("he").getLanguage()))
              ...

      Returns:
        The language code, or the empty string if none is defined.
      See Also:
        `#getDisplayLanguage`

    - #### getScript

          public String getScript()

      Returns the script for this locale, which should either be the empty string or an ISO 15924 4-letter script code. The first letter is uppercase and the rest are lowercase, for example, 'Latn', 'Cyrl'.
      Returns:
        The script code, or the empty string if none is defined.
      Since:
        1.7
      See Also:
        `#getDisplayScript`

    - #### getCountry

          public String getCountry()

      Returns the country/region code for this locale, which should either be the empty string, an uppercase ISO 3166 2-letter code, or a UN M.49 3-digit code.
      Returns:
        The country/region code, or the empty string if none is defined.
      See Also:
        `#getDisplayCountry`

    - #### getVariant

          public String getVariant()

      Returns the variant code for this locale.
      Returns:
        The variant code, or the empty string if none is defined.
      See Also:
        `#getDisplayVariant`

    - #### getExtension

          public String getExtension(char key)

      Returns the extension (or private use) value associated with the specified key, or null if there is no extension associated with the key. To be well-formed, the key must be one of `[0-9A-Za-z]`. Keys are case-insensitive, so for example 'z' and 'Z' represent the same extension.
      Parameters:
        `key` - the extension key
      Returns:
        The extension, or null if this locale defines no extension for the specified key.
      Throws:
        `IllegalArgumentException` - if key is not well-formed
      Since:
        1.7
      See Also:
        `PRIVATE_USE_EXTENSION`, `UNICODE_LOCALE_EXTENSION`

    - #### getExtensionKeys

          public Set<Character> getExtensionKeys()

      Returns the set of extension keys associated with this locale, or the empty set if it has no extensions. The returned set is unmodifiable. The keys will all be lower-case.
      Returns:
        The set of extension keys, or the empty set if this locale has no extensions.
      Since:
        1.7

    - #### getUnicodeLocaleAttributes

          public Set<String> getUnicodeLocaleAttributes()

      Returns the set of unicode locale attributes associated with this locale, or the empty set if it has no attributes. The returned set is unmodifiable.
      Returns:
        The set of attributes.
      Since:
        1.7

    - #### getUnicodeLocaleType

          public String getUnicodeLocaleType(String key)

      Returns the Unicode locale type associated with the specified Unicode locale key for this locale. Returns the empty string for keys that are defined with no type. Returns null if the key is not defined. Keys are case-insensitive. The key must be two alphanumeric characters ([0-9a-zA-Z]), or an IllegalArgumentException is thrown.
      Parameters:
        `key` - the Unicode locale key
      Returns:
        The Unicode locale type associated with the key, or null if the locale does not define the key.
      Throws:
        `IllegalArgumentException` - if the key is not well-formed
        `NullPointerException` - if `key` is null
      Since:
        1.7

    - #### getUnicodeLocaleKeys

          public Set<String> getUnicodeLocaleKeys()

      Returns the set of Unicode locale keys defined by this locale, or the empty set if this locale has none. The returned set is immutable. Keys are all lower case.
      Returns:
        The set of Unicode locale keys, or the empty set if this locale has no Unicode locale keywords.
      Since:
        1.7

    - #### toString

          public final String toString()

      Returns a string representation of this `Locale` object, consisting of language, country, variant, script, and extensions as below:

      > language + "_" + country + "_" + (variant + "_#" | "#") + script + "-" + extensions

      Language is always lower case, country is always upper case, script is always title case, and extensions are always lower case. Extensions and private use subtags will be in canonical order as explained in `#toLanguageTag`.

      When the locale has neither script nor extensions, the result is the same as in Java 6 and prior.

      If both the language and country fields are missing, this function will return the empty string, even if the variant, script, or extensions field is present (you can't have a locale with just a variant, the variant must accompany a well-formed language or country code).

      If script or extensions are present and variant is missing, no underscore is added before the "#".

      This behavior is designed to support debugging and to be compatible with previous uses of `toString` that expected language, country, and variant fields only. To represent a Locale as a String for interchange purposes, use `#toLanguageTag`.

      Examples:

      `
      - en
      - de_DE
      - _GB
      - en_US_WIN
      - de__POSIX
      - zh_CN_#Hans
      - zh_TW_#Hant-x-java
      - th_TH_TH_#u-nu-thai
      `
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the Locale, for debugging.
      See Also:
        `#getDisplayName`, `#toLanguageTag`

    - #### clone

          public Object clone()

      Overrides Cloneable.
      Overrides:
        `clone` in class `Object`
      Returns:
        a clone of this instance.
      See Also:
        `Cloneable`

    - #### hashCode

          public int hashCode()

      Override hashCode. Since Locales are often used in hashtables, caches the value for speed.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        a hash code value for this object.
      See Also:
        `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`

    - #### equals

          public boolean equals(Object obj)

      Description copied from class: `Object`
      Indicates whether some other object is "equal to" this one.

      The `equals` method implements an equivalence relation on non-null object references:

      - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
      - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
      - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
      - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
      - For any non-null reference value `x`, `x.equals(null)` should return `false`.

      The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

      Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the reference object with which to compare.
      Returns:
        `true` if this object is the same as the obj argument; `false` otherwise.
      See Also:
        `Object.hashCode()`, `HashMap`

Copyright © 2025 API Design. All Rights Reserved.